SystemOrganization addCategory: #Rango!
SystemOrganization addCategory: #'Rango-Tests'!

Object subclass: #Rango
	instanceVariableNames: 'start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango'!

!Rango class methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 17:07'!
rangoUniversal 
|universalRange startDate endDate|

startDate:= DateAndTime today.
endDate:= DateAndTime year: 9999 month: 12 day: 31 hour: 23 minute: 59.

universalRange := Rango new.
universalRange start: startDate; end: endDate.

^universalRange .! !

!Rango class methodsFor: 'as yet unclassified' stamp: 'Paul 4/19/2012 16:13'!
start: inicio end: fin
	"Constructor con parametros."

	^ self new
		start: inicio;
		end: fin! !

!Rango methodsFor: 'accessors' stamp: 'LucasGiudice 4/16/2012 11:29'!
end
 ^end.! !

!Rango methodsFor: 'accessors' stamp: 'LucasGiudice 4/16/2012 11:29'!
end: anEnd
 end := anEnd! !

!Rango methodsFor: 'comparing' stamp: 'LucasGiudice 4/16/2012 19:58'!
equals: aRange
	^ self start = aRange start and: [ self end = aRange end.].! !

!Rango methodsFor: 'comparing' stamp: 'LucasGiudice 4/18/2012 17:18'!
includeArgument: anArgument

^ anArgument > self start and: [anArgument < self end]
! !

!Rango methodsFor: 'comparing' stamp: 'Paul 4/19/2012 12:41'!
includes: aRange
"aRange esta incluido si sus extremos estan dentro del rango o son sus extremos, de lo contrario devuelve false"

	"^ ((self includeArgument: aRange start) or: (self start equals: aRange start))
		and: [ (self includeArgument: aRange end) or: (self end equals: aRange end) ]"
		
	^ ((self includeArgument: aRange start) or: (self start = aRange start))
		and: [ (self includeArgument: aRange end) or: (self end = aRange end) ]! !

!Rango methodsFor: 'comparing' stamp: 'LucasGiudice 4/18/2012 10:15'!
overlaps: aRange

"Juro que anda... se me cago la otra imagen donde tenia hechos los tests y es una paja hacerlos de nuevo :P"

^(self includes: aRange) or:[ (self includeArgument: aRange start)
								or: [ (self includeArgument: aRange end ) ] 
							].! !

!Rango methodsFor: 'accessors' stamp: 'Paul 4/16/2012 22:00'!
size
"Devuelve el taman~o del Rango"

 ^end - start.! !

!Rango methodsFor: 'accessors' stamp: 'LucasGiudice 4/16/2012 11:28'!
start
^start! !

!Rango methodsFor: 'accessors' stamp: 'LucasGiudice 4/16/2012 11:29'!
start: aStart
 start := aStart! !

!Rango methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 18:36'!
startingOn: anArgument
"recibe una fecha, devuelve un nuevo rango que empieze en esa fecha y no tenga fin... mas o menos, el final es el fin del mundo que, como todos sabemos, es el 31/12/9999 a las 23.59 :P"

	|aRange endOfTheWorld|
	
	endOfTheWorld :=DateAndTime  year: 9999 month: 12 day: 31 hour: 23 minute: 59.
	
	aRange:= Rango new.
	aRange start: anArgument;
			end: endOfTheWorld.
	
	^aRange.
! !

!Rango methodsFor: 'operators' stamp: 'LucasGiudice 4/18/2012 17:50'!
substract: aRange
"OJO: modifica a self y adems devuelve un Rango nuevo."

|newRange|
newRange:= Rango new.
(self includes: aRange) ifTrue: [
		newRange end: self end.
		newRange start: aRange end.
		self end: aRange start. 
		^newRange.]
	ifFalse: [self error: 'no se puede sustraer un rango a otro si el ltimo no incluye al primero'].! !

TestCase subclass: #RangoIncludes
	instanceVariableNames: 'de12a17 de12a23 de15a20 de17a18 de18a23'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango-Tests'!

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/19/2012 16:36'!
setUp
	| hora12 hora15 hora17 hora18 hora20 hora23 |
	hora12 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 12
		minute: 15.
	hora15 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 15
		minute: 45.
	hora17 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 17
		minute: 15.
	hora18 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 18
		minute: 45.
	hora20 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 20
		minute: 15.
	hora23 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 23
		minute: 45.
	de12a17 := Rango start: hora12 end: hora17.
	de12a23 := Rango start: hora12 end: hora23.
	de15a20 := Rango start: hora15 end: hora20.
	de17a18 := Rango start: hora17 end: hora18.
	de18a23 := Rango start: hora18 end: hora23! !

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/19/2012 16:39'!
testIncludesDateAndTime
	"Valida que un rango grande incluye a otro chico si aquel contiene sus extremos adentro del grande. Pero que el chico no incluye al grande."

	self assert: (de12a23 includes: de15a20).
	self assert: (de15a20 includes: de12a23) not! !

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/19/2012 16:27'!
testIncludesDateAndTimeEquals
	"Valida que un rango incluya a si mismo"

	self assert: (de12a23 includes: de12a23)! !

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/19/2012 16:32'!
testIncludesDateAndTimeExtreme
	"Valida que un rango grande incluye a otro chico si aquel contiene un extremo adentro del grande y otro coincide con un extremo del grande. Pero que el chico no incluye al grande."

	self assert: (de12a23 includes: de12a17).
	self assert: (de12a17 includes: de12a23) not.
	self assert: (de12a23 includes: de18a23).
	self assert: (de18a23 includes: de12a23) not! !

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/19/2012 13:28'!
testIncludesNumeric
	"Valida que un rango grande de numeros incluya rangos mas chicos contenidos en el"

	| unoIncluyeDos rangoUno rangoDos rangoTres rangoCuatro rangoCinco rangoSeis |
	rangoUno := Rango new.
	rangoUno
		start: 10;
		end: 100.
	rangoDos := Rango new.
	rangoDos
		start: 20;
		end: 90.
	self assert: (rangoUno includes: rangoDos).	"10-100 includes: 20-90"
	self assert: (rangoDos includes: rangoUno) not.
	rangoTres := Rango new.
	rangoTres
		start: 10;
		end: 20.
	self assert: (rangoUno includes: rangoTres).	"10-100 includes: 10-20"
	self assert: (rangoTres includes: rangoUno) not.
	rangoCuatro := Rango new.
	rangoCuatro
		start: 90;
		end: 100.
	self assert: (rangoUno includes: rangoCuatro).	"10-100 includes: 90-100"
	self assert: (rangoCuatro includes: rangoUno) not.
	rangoCinco := Rango new.
	rangoCinco
		start: 100;
		end: 200.
	self assert: (rangoUno includes: rangoCinco) not.	"10-100 includes: 100-200"
	self assert: (rangoCinco includes: rangoUno) not.
	rangoSeis := Rango new.
	rangoSeis
		start: 0;
		end: 10.
	self assert: (rangoUno includes: rangoSeis) not.	"10-100 includes: 0-10"
	self assert: (rangoSeis includes: rangoUno) not! !

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/19/2012 16:31'!
testNotIncludesDateAndTimeDiferent
	"Valida que un rango no incluya otro si no tiene nada en comun"

	self assert: (de12a17 includes: de18a23) not.
	self assert: (de18a23 includes: de12a17) not! !

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/19/2012 16:33'!
testNotIncludesDateAndTimeExtreme
	"Dos rango no se incluyen si solo se tocan en los extremos."

	self assert: (de12a17 includes: de17a18) not.
	self assert: (de17a18 includes: de18a23) not! !

!RangoIncludes methodsFor: 'tests' stamp: 'Paul 4/19/2012 16:38'!
testNotIncludesDateAndTimeIntersection
	"Dos rango no se incluyen si solo se solapan en una parte."

	self assert: (de12a17 includes: de15a20) not.
	self assert: (de15a20 includes: de12a17) not.
	self assert: (de18a23 includes: de15a20) not.
	self assert: (de15a20 includes: de18a23) not! !

TestCase subclass: #RangoSize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango-Tests'!

!RangoSize methodsFor: 'tests' stamp: 'Paul 4/16/2012 22:14'!
testSizeDateAndTime
	"Prueba el metodo con los DateAndTime"

	| inicio fin unRango duracionEsperada |
	inicio := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 21
		minute: 0.
	fin := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 22
		minute: 0.
	unRango := Rango new.
	unRango start: inicio.
	unRango end: fin.
	duracionEsperada := Duration
		days: 0
		hours: 1
		minutes: 0
		seconds: 0.
	self assert: duracionEsperada equals: unRango size! !

!RangoSize methodsFor: 'tests' stamp: 'Paul 4/16/2012 22:14'!
testSizeNumerico
	"Prueba el metodo con los numeros"

	| inicio fin unRango |
	inicio := 1.
	fin := 3.
	unRango := Rango new.
	unRango start: inicio.
	unRango end: fin.
	self assert: 2 equals: unRango size! !

TestCase subclass: #TestRangoOverlaps
	instanceVariableNames: 'de12a17 de15a20 de17a18 de18a23'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango-Tests'!

!TestRangoOverlaps methodsFor: 'tests' stamp: 'Paul 4/19/2012 16:12'!
setUp
	| hora12 hora15 hora17 hora18 hora20 hora23 |
	hora12 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 12
		minute: 15.
	hora15 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 15
		minute: 45.
	hora17 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 17
		minute: 15.
	hora18 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 18
		minute: 45.
	hora20 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 20
		minute: 15.
	hora23 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 23
		minute: 45.
	de12a17 := Rango start: hora12 end: hora17.
	de15a20 := Rango start: hora15 end: hora20.
	de17a18 := Rango start: hora17 end: hora18.
	de18a23 := Rango start: hora18 end: hora23! !

!TestRangoOverlaps methodsFor: 'tests' stamp: 'Paul 4/19/2012 14:04'!
testNotOverlaps
	"Valida que no se solapan los rangos que no tienen nada en comun."

	self assert: (de12a17 overlaps: de18a23) not.
	self assert: (de18a23 overlaps: de12a17) not! !

!TestRangoOverlaps methodsFor: 'tests' stamp: 'Paul 4/19/2012 14:06'!
testNotOverlapsExtreme
	"Valida que no se solapan los rangos que solo comparten los extremos."

	self assert: (de12a17 overlaps: de17a18) not.
	self assert: (de17a18 overlaps: de18a23) not! !

!TestRangoOverlaps methodsFor: 'tests' stamp: 'Paul 4/19/2012 16:03'!
testOverlapsEquals
	"Valida que se solapan los rangos queson iguales."

	self setUp.
	self assert: (de15a20 overlaps: de15a20)! !

!TestRangoOverlaps methodsFor: 'tests' stamp: 'Paul 4/19/2012 13:53'!
testOverlapsIntersection
	"Valida que se solapan los rangos que tienen interseccion."

	self assert: (de12a17 overlaps: de15a20).
	self assert: (de15a20 overlaps: de12a17)! !

TestCase subclass: #TestRangoStartingOn
	instanceVariableNames: 'rangoUno rangoTres'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango-Tests'!

!TestRangoStartingOn methodsFor: 'tests' stamp: 'LucasGiudice 4/18/2012 18:33'!
setUp 
 
|inicioRango1  finRango1  inicioRango3 finRango3 |

inicioRango1 := DateAndTime year: 2012 month: 04 day: 18 hour: 0  minute: 0.
finRango1 := DateAndTime year: 2012 month: 04 day: 16 hour: 22  minute: 15.

 
inicioRango3 := DateAndTime year: 2012 month: 04 day: 18 hour: 0  minute: 0.
finRango3 := DateAndTime year: 9999 month: 12 day: 31 hour: 23  minute: 59.



rangoUno:= Rango new.
rangoUno start: inicioRango1; end: finRango1.

rangoTres:= Rango new.
rangoTres start: inicioRango3; end: finRango3.
! !

!TestRangoStartingOn methodsFor: 'tests' stamp: 'LucasGiudice 4/18/2012 18:35'!
testUnoStartingOnUnaFecha

| aRange |
aRange := rangoUno startingOn: rangoUno start.

self assert: (rangoTres equals: aRange).! !

TestCase subclass: #TestRangoSubstract
	instanceVariableNames: 'de12a17 de12a23 de17a18 de18a23'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rango-Tests'!

!TestRangoSubstract methodsFor: 'tests' stamp: 'Paul 4/19/2012 22:34'!
setUp
	| hora12 hora15 hora17 hora18 hora20 hora23 |
	hora12 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 12
		minute: 0.
	hora15 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 15
		minute: 0.
	hora17 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 17
		minute: 0.
	hora18 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 18
		minute: 0.
	hora20 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 20
		minute: 0.
	hora23 := DateAndTime
		year: 2012
		month: 04
		day: 16
		hour: 23
		minute: 0.
	de12a17 := Rango start: hora12 end: hora17.
	de12a23 := Rango start: hora12 end: hora23.
	de17a18 := Rango start: hora17 end: hora18.
	de18a23 := Rango start: hora18 end: hora23! !

!TestRangoSubstract methodsFor: 'tests' stamp: 'Paul 4/19/2012 23:42'!
testSubstractIncludes
	"Se substrae de un rango grande otro mas chico. Como el resultado se devuelve el pedazo posterior que quedo del grande."

	self assert: (de18a23 includes: (de12a23 substract: de17a18)).
	self assert: (de12a17 includes: de12a23)	"Ojo!! Parece raro pero pasa que el rango de12a23 ahora es distinto:  solo es el pedazo anterior del resultado de la substraccion."! !
